Subject: Re: [UDP6]: Restore sk_filter optimisation

From: Mitsuru Chinen <[email-masked]>
Date: Wed, 31 Oct 2007 23:05:45 +0900

On Mon, 29 Oct 2007 20:53:28 +0800
Herbert Xu <[email-masked]> wrote:

> On Mon, Oct 29, 2007 at 03:33:20PM +0900, Mitsuru Chinen wrote:
> > Hello Herbert,
> > 
> > Let me ask a question about this patch.
> > After this patch was applied, 2 of the protocol stack behaviors were
> > changed when it receives a UDP datagram with broken checksum:
> > 
> >  1. udp6InDatagrams is incremented instead of udpInErrors
> >  2. In userland, recvfrom() replies an error with EAGAIN.
> >     recvfrom() wasn't aware of such a packet before.
> > 
> > Are these changes intentional?
> 
> It wasn't my intention if that's what you mean :)
> 
> However, this would've happened with the old code anyway if
> someone had a filter attached so this isn't new.
>
> If it's a problem then we should just get it fixed.

As far as I tested, this doesn't happen with the old code even if
a filter is attached. However, this happen with the new code
without a filter and I don't see this rather when a filter is
attached. So, I'm afraid it's new.

By the way, could you answer the Yoshifuji-san's question?
I think the code where we should fix depends on this. 

On Mon, 29 Oct 2007 15:41:50 +0900 (JST)
YOSHIFUJI Hideaki / 吉藤英明 <[email-masked]> wrote:

> And, we're not sure how much the "optimization"'s benefit is.
> It is even worse when we are handling multicast packets.

Thank you,
----
Mitsuru Chinen <[email-masked]>